#!perl
$wids = <>; # Outer window is 0x4000001, inner window is 0x4000002
$xxx = <>;

while(<>) {
    &handleevent($ev) if (/^$/);
    $ev = "" if (/^$/);
    $ev .= $_ unless(/^$/);
}

open(HFILE,">xev.h"); select(HFILE);
print "unsigned short states[] = {\n";
for $i (sort keys %states) {
    printf "/* 0x%02x */ 0x%x,\n",ord($i),$states{$i};
}
print "};\n\n";
print "KeyCode keycodes[] = {\n";
for $i (sort keys %states) {
    printf "/* 0x%02x */ 0x%x,\n",ord($i),$keycodes{$i};
}
print "};\n";
select(STDOUT);
close(HFILE);

sub handleevent {
    local($ev) = @_;
    ($type, $serial, $synth, $window) = 
	($ev =~ /^(\w+) event, serial (\d+), synthetic (\w+), window (\w+),/);
    print "type $type, serial $serial\n";
    return if ($type ne "KeyPress");
    ($state,$keycode) = 
	($ev =~ /state 0x(.+), keycode (.+) \(/);
    ($xlen,$xls) = 
	($ev =~ /XLookupString gives (\d+) characters:  "([\000-\255]+)"$/);
    print "State: $state Keycode: $keycode Len: $xlen xls: <$xls>\n";
    $states{$xls} = $state;
    $keycodes{$xls} = $keycode;
}

	
